<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Markus Kappe (markus.kappe@beko.at)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Module 'BE User Log' for the 'beko_beuserlog' extension.
 *
 * @author	Markus Kappe <markus.kappe@beko.at>
 */



	// DEFAULT initialization of a module [BEGIN]
unset($MCONF);	
require ("conf.php");
require ($BACK_PATH."init.php");
require ($BACK_PATH."template.php");
$LANG->includeLLFile("EXT:beko_beuserlog/mod1/locallang.php");
#include ("locallang.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]

class tx_bekobeuserlog_module1 extends t3lib_SCbase {
	var $pageinfo;

	/**
	 * 
	 */
	function init()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
		
		parent::init();

		/*
		if (t3lib_div::_GP("clear_all_cache"))	{
			$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
		}
		*/
	}

	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 */
	function menuConfig()	{
		global $LANG;
		$this->MOD_MENU = Array (
			"function" => Array (
				"1" => $LANG->getLL("function1"), // successful
				"2" => $LANG->getLL("function2"), // failed
			)
		);
		parent::menuConfig();
	}

		// If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	/**
	 * Main function of the module. Write the content to $this->content
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
		
		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;
		
		if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))	{
	
				// Draw the header.
			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;
			$this->doc->form='<form action="" method="POST">';

				// JavaScript
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
			';
			$this->doc->postCode='
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
				</script>
			';

			$headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
			$this->content.=$this->doc->divider(5);

			
			// Render content:
			$this->moduleContent();

			
			// ShortCut
			if ($BE_USER->mayMakeShortcut())	{
				$this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
			}
		
			$this->content.=$this->doc->spacer(10);
		} else {
				// If no access or if ID == zero
		
			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;
		
			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->spacer(10);
		}
	}

	/**
	 * Prints out the module HTML
	 */
	function printContent()	{

		$this->content.=$this->doc->endPage();
		echo $this->content;
	}
	
	/**
	 * Generates the module content
	 */
	function moduleContent()	{
		global $LANG;
		if (t3lib_div::_GP('csv')) {
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('distinct tstamp, ip, log_data, action','sys_log','type = 255 and action in (1,3)','','tstamp desc', '300');
			header('Content-type: text/csv');
			header('Content-Disposition: attachment; filename="logins.csv"');
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
				$log_data = unserialize($row['log_data']);
				$username = ($row['action'] == 1) ? $log_data[0] : $log_data[2]; // username is stored in different variables depending if login was successful or not

				$succ = ($row['action'] == 1) ? $LANG->getLL("success") : $LANG->getLL("failed");
				printf('"%s";"%s";"%s";"%s"', date('d.m.Y H:i', $row['tstamp']), $username, $row['ip'], $succ);
				echo "\n";
			}
			exit();
		}
		
		switch((string)$this->MOD_SETTINGS["function"])	{
			case 1: // successful
				//$query = "select tstamp, ip, log_data from sys_log where type = 255 and action = 1
				// action = 3 for failed
				
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('distinct tstamp, ip, log_data','sys_log','type = 255 and action = 1','','tstamp desc', '30');
				$content = "<table>";
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
					$log_data = unserialize($row['log_data']);
					$content .= sprintf('<tr><td>%s</td><td>%s</td><td>%s</td></tr>', date('d.m.Y - H:i', $row['tstamp']), $log_data[0], $row['ip']);
				}
				$content .= "</table>";
		
				$this->content.=$this->doc->section($LANG->getLL("function1").":",$content,0,1);
				$content = '<p><a href="index.php?csv=1">'.$LANG->getLL("csv_link").'</a></p>';
				$this->content.=$this->doc->section($LANG->getLL("export"),$content,0,1);
			break;
			case 2: // failed
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('distinct tstamp, ip, log_data','sys_log','type = 255 and action = 3','','tstamp desc', '30');
				
				$content = "<table>";
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
					$log_data = unserialize($row['log_data']);
					$content .= sprintf('<tr><td>%s</td><td>%s</td><td>%s</td></tr>', date('d.m.Y - H:i', $row['tstamp']), $log_data[2], $row['ip']);
				}
				$content .= "</table>";
		
				$this->content.=$this->doc->section($LANG->getLL("function2").":",$content,0,1);
				$content = '<p><a href="index.php?csv=1">'.$LANG->getLL("csv_link").'</a></p>';
				$this->content.=$this->doc->section($LANG->getLL("export"),$content,0,1);
			break;
		} 
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/beko_beuserlog/mod1/index.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/beko_beuserlog/mod1/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_bekobeuserlog_module1");
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>